package rndclub.game.mobiletetris;
import java.lang.*;
import java.util.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class Mine extends MIDlet implements CommandListener {
   Display disp;
   private Command cmdNew=new Command("New",Command.SCREEN,1);
   private Command cmdExit=new Command("Exit",Command.SCREEN,2);

   MineCanvas canvas;

   public Mine() {
      disp=Display.getDisplay(this);
   }

   public void startApp() {
      canvas=new MineCanvas(disp);
      canvas.start();
      canvas.addCommand(cmdExit);
      canvas.addCommand(cmdNew);
      canvas.setCommandListener(this);
   }

   public void pauseApp() {
   }

   public void destroyApp(boolean uc) {
   }

   public void commandAction(Command c,Displayable s) {
      if(c == cmdExit) {
         destroyApp(false);
         notifyDestroyed();
      } else if(c == cmdNew) {
         canvas.newGame();
      }
   }	
}
