<%@ page contentType="text/html; charset=euc-kr" %>

<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>

<%
   String yourId = request.getParameter("id");
   String yourScoreStr = request.getParameter("score");
   int yourScoreInt = 0;
   try {
      yourScoreInt = Integer.parseInt(yourScoreStr);
   } catch(NumberFormatException e) {
      return;
   }
   if(yourId == null) {
      yourId = "...";
   }
%>

<HTML>
<HEAD>
<TITLE>Score Board</TITLE>
</HEAD>

<BODY>

<CENTER>
<BR>
<H2>Score Board</H2>
<BR>
<HR>
<BR>

<table width=560 cellspacing=1 cellpadding=2 border>	
   <tr align=center>
      <th width=120 align=center bgcolor=#ffffff></th>
      <th width=240 align=center bgcolor=#ffffff>̵</th>
      <th width=200 align=center bgcolor=#ffffff></th>
   </tr>
   <tr><td colspan=3></td></tr>

<%
   ServletContext context = pageContext.getServletContext();
   String scorePath = context.getRealPath("/gamepark/HiddenCatch/ScoreBoard")
                    + File.separator + "ScoreBoard.txt";

   File scoreFile = new File(scorePath);

   BufferedReader in = new BufferedReader(new FileReader(scoreFile));
   int rank=1;
   boolean flag=false;
   String lineStr=null;
   Hashtable idHash = new Hashtable();
   Hashtable scoreHash = new Hashtable();
   while((lineStr=in.readLine()) != null) {
      lineStr = lineStr.trim();
      if("".equals(lineStr)) {
         continue;
      }
      String id = "";
      String scoreStr = "0";
      int index = lineStr.lastIndexOf("=");
      if(index >= 0) {
         id = lineStr.substring(0, index).trim();
         scoreStr = lineStr.substring(index+1).trim();
      } else {
         id = lineStr;
      }

      int scoreInt = 0;
      try {
         scoreInt = Integer.parseInt(scoreStr);
      } catch(NumberFormatException e) {
      }

      if(yourScoreInt > scoreInt) {
         flag = true;
         idHash.put(""+(rank), yourId);
         scoreHash.put(""+(rank++), yourScoreStr);
      }
      idHash.put(""+(rank), id);
      scoreHash.put(""+(rank++), scoreStr);
      if(rank > 10) {
         break;
      }
   }
   in.close();

   if(flag == false) {
      idHash.put(""+(rank), yourId);
      scoreHash.put(""+(rank++), yourScoreStr);
   }

   PrintWriter pout = new PrintWriter(new FileWriter(scoreFile));
   for(int i=1;i<=10;i++) {
      String id = (String)idHash.get(""+i);
      String score = (String)scoreHash.get(""+i);

      if((id == null)||(score == null)) {
         break;
      }

      pout.println(id+"="+score);
%>
      <tr>
         <td width=120 align=center bgcolor=#ffffff><%= i %></td>
         <td width=240 align=center bgcolor=#ffffff><%= id %></td>
         <td width=220 align=right bgcolor=#ffffff>
<%
      for(int j=0;j<score.length();j++) {
%><img src='<%= score.charAt(j) %>.jpg' border=0 align='middle'><%
      }
%>
         </td>
      </tr>
<%
   }
   pout.close();
%>
   <tr align=center>
      <th width=120 align=center bgcolor=#ffffff>Your Score</th>
      <th width=200 align=center bgcolor=#ffffff><%= yourId %></th>
      <th width=200 align=right bgcolor=#ffffff>
<%
   for(int j=0;j<yourScoreStr.length();j++) {
%><img src='<%= yourScoreStr.charAt(j) %>.jpg' border=0 align='middle'><%
   }
%>
      </th>
   </tr>
</table>
<BR>
<HR>
<BR>
[ <a href="../ShinKyoungShoiYak.jsp">Back</a> ]
</BODY>
</HTML>
