package rndclub.game.samepiece;
import java.awt.*;

// ӿ   ð ¸ ֱ  ο Ʈ 
class TimeBar extends Canvas {
   int time, maxTime;

   public TimeBar(int maxTime) {
      this.time = 0;
      this.maxTime = maxTime;

      setForeground(new Color(0xff, 0x99, 0x00));  // ¹  
      setBackground(new Color(0x22, 0x22, 0x66));  //  

      setSize(maxTime*3, 16);   // ũ 
   }

   //  ð Ѵ.
   int getTime() {
      return(time);
   }

   //  ð Ѵ.
   void setTime(int time) {
      this.time = time;
      repaint();  // ð ϸ ¹ٸ ٽ ׷־ Ѵ.
   }

   //  ü  ð Ѵ.
   int getMaxTime() {
      return(maxTime);
   }

   // ü  ð Ѵ.
   void setMaxTime(int maxTime) {
      this.maxTime = maxTime;
      repaint();  // ü  ð ϸ ¹ٸ ٽ ׷־ Ѵ.
   }

   // repaint() ޼ҵ带 ν, paint() ޼ҵ尡 ٷ ǵ 
   public void repaint() {
      update(getGraphics());
   }

   // uppaint() ޼ҵ带 ν   
   public void update(Graphics g) {
      paint(g);
   }

   //  ð ° ¹ٸ ׷ش.
   public void paint(Graphics g) {
      if(g == null) return;

      //  ðŭ κ ׷ش.
      //  θ     ٸ  ׸. ||| 
      for(int i=0;i<time;i++) {
         g.setColor(getForeground());
         g.drawLine(i*3, 0, i*3, 15);
         g.drawLine(i*3+1, 0, i*3+1, 15);
         g.setColor(Color.lightGray);
         g.drawLine(i*3+2, 0, i*3+2, 15);
      }

      //   κ ׷ش.
      //  θ     ٸ  ׸. ||| 
      for(int i=time;i<maxTime;i++) {
         g.setColor(getBackground());
         g.drawLine(i*3, 0, i*3, 15);
         g.drawLine(i*3+1, 0, i*3+1, 15);
         g.setColor(Color.black);
         g.drawLine(i*3+2, 0, i*3+2, 15);
      }

      //  ð Ʈ ߾ӿ  ش.
      String str = ""+time;  // ڿ ȯϱ    
      FontMetrics fm = Toolkit.getDefaultToolkit().getFontMetrics(getFont());

      // ð  ۾ ٸ ؾ .
      // ð ߾ Ѿ 쿡  ۾ ϰ,
      // ð ߾   쿡  ۾ Ѵ.
      if((getSize().width >> 1) > time*3) {
         g.setColor(Color.white);
      } else {
         g.setColor(Color.blue);
      }
      // ¹ ߾ӿ ۾ 
      g.drawString(str, getSize().width - fm.stringWidth(str) >> 1, 12);
   }
}
