/*
 * Copyright (c) 2000 Yongwoo's Park. All Rights Reserved.
 */

package rndclub.game.godori;
import java.net.*;
import java.io.*;
import java.util.*;

/*
 * 뿡 ִ Ŭ̾Ʈ(÷̾) ϱ   
 * 뿡   ִ Ŭ̾Ʈ    ൵ Ѵ.
 */

class GRoom extends Thread {
   final static int PAE_NUMBER=49;           // ȭ  
   final static int PARTICIPANT_NUMBER=10;   //  뿡 10   .
   final static int SESSION_MAN_NUMBER=3;    //    ĥ  

   int numPlayer=0, count=0, endedPlayer=0;  // Connected Counter
   GServerPlayer hostPlayer=null;            //   Ŭ̾Ʈ

   Vector playerList=null;          //   ġ ִ ÷̾ Ʈ
   Vector participantList=null;     //  濡 ִ ÷̾ Ʈ
   Vector sessionManList=null;      //  ġ ִ ÷̾ Ʈ
   int sessionManScore[]=null;      //  ġ ÷̾ 

   Vector badakPaeList=null;        // ٴ Ʈ
   Vector giriPaeList=null;         // ⸮ Ʈ
   Vector playerPaeList[]=null;     //     Ʈ

   //  ĥ    ٴи ֱ  Ѵ.
   int paeList[]=null;        //  Ʈ
   boolean paeFlag[]=null;    // и  

   public String roomId=null;       //  ̵
   boolean onSession=false;         //  ġ  
   int currentPlayer=0;             //  ÷̾ 
   int winnerPlayer=-1;             //    ÷̾ ȣ (  Ѹ)
   String winnerPlayerId=null;      //   ÷̾ ̵

   // ־ ̵   ü Ѵ.
   //  , ־ ÷̾  ȴ.
   public GRoom(String roomId, GServerPlayer player) {
      this.hostPlayer = player;     //  
      playerList = new Vector();    //   ִ ÷̾ Ʈ
      participantList = new Vector();  //  ӿ ϰ ִ  Ʈ

      sessionManList = new Vector();   //  ġ ִ ÷̾ Ʈ
      sessionManScore = new int[3];    //  ġ ִ    
      sessionManScore[0] = 0;          // 1 ° ġ   ʱȭ
      sessionManScore[1] = 0;          // 2 ° ġ   ʱȭ
      sessionManScore[2] = 0;          // 3 ° ġ   ʱȭ

      giriPaeList = new Vector();                     // ⸮
      badakPaeList = new Vector();                    // ٴ

      playerPaeList = new Vector[SESSION_MAN_NUMBER]; //  ÷̾  迭
      playerPaeList[0] = new Vector();                // 1° ÷̾ 
      playerPaeList[1] = new Vector();                // 1° ÷̾ 
      playerPaeList[2] = new Vector();                // 1° ÷̾ 

      //  ĥ    ٴи ֱ  Ѵ.
      paeList = new int[PAE_NUMBER];                  // ü  Ʈ
      paeFlag = new boolean[PAE_NUMBER];              // и  

      //  ̵ ϰ
      //  ־ ÷̾  Ŭ̾Ʈ Ʈ ߰
      this.roomId = roomId;
      addPlayer(player);

      // и ʱȭ Ѵ.
      clearPae();
   }

   // ǿ   Ŭ̾Ʈ ߰Ѵ.
   public void addPlayer(GServerPlayer player) {
      if(!playerList.contains(player)) {
         player.room = this;              // Ŭ̾Ʈ   
         playerList.addElement(player);   // Ŭ̾Ʈ Ʈ ߰
      }
   }

   // ־ ̵ شϴ Ŭ̾Ʈ  ´.
   public GServerPlayer getPlayer(String playerId) {
      GServerPlayer player=null;
      for(int i=0;i<playerList.size();i++) {
         player = (GServerPlayer)playerList.elementAt(i);
         if(player.id.equals(playerId)) {
            return(player);
         }
      }
      return(null);
   }

   // ־ Ŭ̾Ʈ 뿡 Ѵ.
   //  , Ŭ̾Ʈ ܼ   ִ,
   // Ǵ  ġ ִ  ٸ ó ־ Ѵ.
   synchronized public void removePlayer(GServerPlayer player) {
      String setRunawayQuery="";

      if(player == null) {
         return;
      }

      // , ÷̾  Ѵ.
      player.room = null;                 //   , null 
      player.lobby.takePlayer(player);    // Ŭ̾Ʈ 뿡 κ ̵
      playerList.removeElement(player);   // Ŭ̾Ʈ 뿡 

      participantList.removeElement(player); //  Ʈ 
      if(sessionManList.contains(player)) {
         // ,  Ŭ̾Ʈ  ġ  쿡
         //   .
         // ֳϸ, ڷμ  ϰ, ο   ؾ Ѵ.
         if(onSession == true) {
            // ,  ġ ִ ߿   쿡
            //  Ŭ̾Ʈ  Ģ ؾ Ѵ.
            try {
               //   ġ ִ ÷̾ (̵) ȮѴ.
               String id1 = ((GServerPlayer)sessionManList.elementAt(0)).id;
               String id2 = ((GServerPlayer)sessionManList.elementAt(1)).id;
               String id3 = ((GServerPlayer)sessionManList.elementAt(2)).id;

               //   ġ ִ ÷̾  Ʈ ȮѴ.
               String paeList[] = new String[3];
               for(int i=0;i<playerPaeList.length;i++) {
                  paeList[i] = "";
                  for(int j=0;j<playerPaeList[i].size();j++) {
                     int pae = ((Integer)playerPaeList[i].elementAt(j)).intValue();
                     paeList[i] += pae + ",";
                  }
                  if(paeList[i].endsWith(",")) {
                     paeList[i] = paeList[i].substring(0, paeList[i].length()-1);
                  }
               }

               //  ġ ִ  Ȳ   
               // ͺ̽ ϱ , 
               //   ƹ Ŭ̾Ʈ .
               // Ŭ̾Ʈ   ̿Ͽ  SetRunaway.jsp ȣϿ
               // ͺ̽ ش  ϵ Ѵ.
               setRunawayQuery  = "runaway=" + URLEncoder.encode(player.id)
                                + "&roomId=" + URLEncoder.encode(roomId)
                                + "&sessionMan1=" + URLEncoder.encode(id1)
                                + "&sessionManScore1=" + sessionManScore[0]
                                + "&paeList1=" + URLEncoder.encode(paeList[0])
                                + "&sessionMan2=" + URLEncoder.encode(id2)
                                + "&sessionManScore2=" + sessionManScore[1]
                                + "&paeList2=" + URLEncoder.encode(paeList[1])
                                + "&sessionMan3=" + URLEncoder.encode(id3)
                                + "&sessionManScore3=" + sessionManScore[2]
                                + "&paeList3=" + URLEncoder.encode(paeList[2]);
      		 } catch(Exception e) {
            }
         }

         // ϴ, ÷̾  ġ  Ʈ Ѵ.
         sessionManList.removeElement(player);

         if(sessionManList.size() > 0) {
            //  ġ ִ  θ  Ѹ
            // ޽  ڿ  Ȳ ͺ̽ ϵ Ѵ.
            GServerPlayer pp = (GServerPlayer)playerList.elementAt(0);
            pp.sendMessage("690|"+pp.id+"|"+setRunawayQuery);
         } else {
         }

         // ÷̾   ־ 쿡,
         //   winnerPlayerId   .
         if(player.id.equals(winnerPlayerId)) {
            winnerPlayerId = null;
            winnerPlayer = -1;
         }
      }

      if(playerList.size() == 0) {
         // ÷̾  , 뿡 ƹ ٸ  ؾ Ѵ.
         player.lobby.removeRoom(roomId);
      }

      //   ġ  3 ȵǸ
      //     ٷ Ѵ.
      if(sessionManList.size() < 3) {
         //     ٷ Ѵٴ ޽ .
         String message = "606|*|ڰ    ٸϴ...";
         broadcastMessage(message);

         // ( ġ ִ   ) Ѵ.
         finishSession();

         //   ĥ  ޽ .
         //  ޽ ־ Ŭ̾Ʈ ư (Ȱ/Ȱ) 缳ȴ.
         message = "650|*|GO/DIE?";
         broadcastMessage(message);

         //   ٸ ÷̾    ֵ Ѵ.
         message = "650|*|JOINSESSION";
         //   ֵ JOIN ư Ȱȭ Ѵ..
         broadcastMessage(message);
      }

      //   Ƿ ÷̾ Ʈ ٽ ˷ش.
      informPlayerList();
   }

   // ־ ̵  ÷̾Ʈ 뿡 Ѵ.
   synchronized public void removePlayer(String playerId) {
      GServerPlayer player=null;
      for(int i=0;i<playerList.size();i++) {
         // ־ ̵  ÷̾ ã´.
         player = (GServerPlayer)playerList.elementAt(i);
         if(player.id.equals(playerId)) {
            break;
         }
         player = null;
      }

      // ־ ̵  ÷̾ GServerPlayer ü ̿Ͽ
      // removePlayer(player) ޼ҵ带 ٽ ȣѴ.
      removePlayer(player);
   }

   // (⸮, ٴ,  )  ʱȭѴ.
   public void clearPae() {
      // и ֱ    Ʈ ʱȭ
      for(int i=0;i<PAE_NUMBER;i++) {
         paeList[i] = -1;
         paeFlag[i] = false;
      }
      giriPaeList.removeAllElements();       // ⸮ ʱȭ
      badakPaeList.removeAllElements();      // ٴ ʱȭ

      playerPaeList[0].removeAllElements();  // 1 ° ÷̾  ʱȭ
      playerPaeList[1].removeAllElements();  // 2 ° ÷̾  ʱȭ
      playerPaeList[2].removeAllElements();  // 3 ° ÷̾  ʱȭ
   }

   // ־ ÷̾   ġ ִ θ 
   boolean inSession(GServerPlayer player) {
      if((sessionManList.size() == 0)&&(playerList.size() == 0)) {
         return(false);
      }
      if(sessionManList.contains(player)) {
         // ÷̾ sessionManList   쿡  ġ ִ.
         return(true);
      }
      return(false);
   }

   // ־ ÷̾ ÷̾ Ʈ  ش.
   void informPlayerList(GServerPlayer targetPlayer) {
      String message=null;
      GServerPlayer player=null;

      //   ƹ  쿡 ׳ Ѵ.
      if((sessionManList.size() == 0)&&(playerList.size() == 0)) {
         return;
      }

      //  Ʈ   ޽ ʱȭ
      message = "632|*|";
      //   

      // ǿ  ÷̾  Ʈ ߰Ѵ.
      //  ̵ պκп "**__**" ڿ  쿡
      //  ڴ  ġ ִٴ  ǹѴ.
      // Ŭ̾Ʈ   ̿Ͽ ÷̾ Ѵ.
      Enumeration e = sessionManList.elements();
      while(e.hasMoreElements()) {
         player = (GServerPlayer)e.nextElement();
         message += "**__**" + player.id + ","; //   ǥ
      }

      //   ÷̾ ߿  ġ ִ
      //  ߰ ڸ   Ʈ ߰Ѵ.
      e = playerList.elements();
XXXXX:
      while(e.hasMoreElements()) {
         player = (GServerPlayer)e.nextElement();
         Enumeration ee = sessionManList.elements();
         while(ee.hasMoreElements()) {
            GServerPlayer p = (GServerPlayer)ee.nextElement();
            if(p.id.equals(player.id)) {
               //  Ʈ ִ ÷̾  ̹ ߰ϿǷ,
               //  while  ǵư Ѵ.
               continue XXXXX;
            }
         }
         //   ִ ڰ ߿  ġ ʴ ڴ
         // ׳ ̸ Ʈ ߰Ѵ.
         // ٽ ؼ, ̵ ̸ տ "**__**" ڿ .
         message += player.id + ","; //   ǥ
      }

      // Ʈ  '.'   쿡 ݵ  ־ Ѵ.
      if(message.endsWith(",")) {
         message = message.substring(0, message.length()-1);
      }

      // ־ ÷̾   ÷̾ Ʈ  ޽ .
      targetPlayer.sendMessage(message);

      // ־ ÷̾ κ ϵǾ ִ  Ʈ .
      targetPlayer.lobby.broadcastRoomList();
   }

   // ־ ÷̾ ÷̾ Ʈ  ش.
   void informPlayerList() {
      String message=null;
      GServerPlayer player=null;

      //   ƹ  쿡 ׳ Ѵ.
      if((sessionManList.size() == 0)&&(playerList.size() == 0)) {
         return;
      }

      //  Ʈ 
      message = "632|*|";
      //   

      // ǿ  ÷̾  Ʈ ߰Ѵ.
      //  ̵ պκп "**__**" ڿ  쿡
      //  ڴ  ġ ִٴ  ǹѴ.
      // Ŭ̾Ʈ   ̿Ͽ ÷̾ Ѵ.
      Enumeration e = sessionManList.elements();
      while(e.hasMoreElements()) {
         player = (GServerPlayer)e.nextElement();
         message += "**__**" + player.id + ","; //   ǥ
      }

      //   ÷̾ ߿  ġ ִ
      //  ߰ ڸ   Ʈ ߰Ѵ.
      e = playerList.elements();
XXXXX:
      while(e.hasMoreElements()) {
         player = (GServerPlayer)e.nextElement();
         Enumeration ee = sessionManList.elements();
         while(ee.hasMoreElements()) {
            GServerPlayer p = (GServerPlayer)ee.nextElement();
            if(p.id.equals(player.id)) {
               //  Ʈ ִ ÷̾  ̹ ߰ϿǷ,
               //  while  ǵư Ѵ.
               continue XXXXX;
            }
         }
         //   ִ ڰ ߿  ġ ʴ ڴ
         // ׳ ̸ Ʈ ߰Ѵ.
         // ٽ ؼ, ̵ ̸ տ "**__**" ڿ .
         message += player.id + ","; //   ǥ
      }

      // Ʈ  '.'   쿡 ݵ  ־ Ѵ.
      if(message.endsWith(",")) {
         message = message.substring(0, message.length()-1);
      }

      //    ÷̾ ÷̾ Ʈ  ޽ εĳѴ.
      broadcastMessage(message);

      // ־ ÷̾ κ ϵǾ ִ  Ʈ .
      player.lobby.broadcastRoomList();
   }

   //    , и ֱ  ´.
   public void shakePae() {
      int pae=0, paeCount=0;

      // и Ǵ ´.
      //  а 49   ݺ
      while(paeCount < PAE_NUMBER) {
         pae = (int)Math.floor(Math.random() * 49);   // Ŀ 49(0..48)
         if(paeFlag[pae] == true) {
            // ̹  ϰ쿡 ó ٽϿ ٸ и ´.
            continue;
         }
         paeFlag[pae] = true;
         paeList[pae] = paeCount++;    //    
      }
   }

   //  ġ  (ٴ, ⸮,  ) .
   // ݵ, shakePae() ޼ҵ带 ȣ Ŀ ȣǾ Ѵ.
   void distributionPae() {
      int paeIndex=0;
      String message=null;
      GServerPlayer player=null;

      // ٴ  ޽ ʱȭ
      message = "630|$$ٴ$$|";

      // , ٴи 6 .
      for(int i=0;i<6;i++) {
         message += paeList[paeIndex] + ",";
         // ٴ Ʈ 
         badakPaeList.addElement(new Integer(paeList[paeIndex]));
         paeIndex++;
      }

      //  ߰ ',' Ѵ.
System.out.println("MESSAGE: ["+message+"]");
      if(message.endsWith(",")) {
         message = message.substring(0, message.length()-1);
      }

      // 6 ٴ Ʈ ο Ѵ.
      //  ġ     ϴ Ե .
System.out.println("MESSAGE: ["+message+"]");
      broadcastMessage(message);

      //    ڿ и 7徿  ش.
      for(int i=0;i<3;i++) {
         int index = ((currentPlayer+i) % SESSION_MAN_NUMBER);
         player = (GServerPlayer)sessionManList.elementAt(index);

         // ޽ ʱȭ
         message = "630|"+player.id+"|";
         for(int j=0;j<7;j++) {
            message += paeList[paeIndex] + ",";
            paeIndex++;
         }
          //  ߰ ',' Ѵ.
         if(message.endsWith(",")) {
            message = message.substring(0, message.length()-1);
         }

         // 7    Ʈ  ο Ѵ.
         //  ġ     ϴ Ե .
         broadcastMessage(message);
      }

      // ⸮  ޽ ʱȭ
      message = "630|$$⸮$$|";
      for(;paeIndex<PAE_NUMBER;paeIndex++) {
         message += paeList[paeIndex] + ",";
         // ٴ Ʈ 
         giriPaeList.addElement(new Integer(paeList[paeIndex]));
      }
       //  ߰ ',' Ѵ.
      if(message.endsWith(",")) {
         message = message.substring(0, message.length()-1);
      }

      //  ⸮ Ʈ  ο Ѵ.
      //  ġ     ϴ Ե .
      broadcastMessage(message);

   }

   //   () Ѵ.
   synchronized public void startSession() {
      String message=null;

      //  ڰ 3 ٸ   ʰ ......
      if(sessionManList.size() < 3) {
         message = "606|*|ڰ    ٸϴ...";
         broadcastMessage(message);
         return;
      }

      clearPae();             // (⸮, ٴ,  ) ʱȭ Ѵ
      shakePae();             // и ´.
      informPlayerList();     // ÷̾  εĳѴ.
      distributionPae();      // (⸮, ٴ,  ) .

      //  Ѵ.
      currentPlayer = -1;
      Enumeration e = sessionManList.elements();
      for(int i=0;i<sessionManList.size();i++) {
         GServerPlayer player = (GServerPlayer)sessionManList.elementAt(i);
         if(player.id.equals(winnerPlayerId)) {
            //  ǿ ̱   Ѵ.
            currentPlayer = i;
         }
      }

      //  ó ġ 쿡   Ѵ.
      if(currentPlayer == -1) {
         currentPlayer = 0;
      }
      winnerPlayer = currentPlayer;

      //  ϵ ޽ .
      message = "650|*|STARTSESSION";
      broadcastMessage(message);

      //  ۵ǾǷ ÷(onSession) Ѵ.
      onSession = true;

      //  ġ   ʱȭ Ѵ.
      sessionManScore[0] = 0;
      sessionManScore[1] = 0;
      sessionManScore[2] = 0;

      // ̹ ʿ ĥ   ޽ .
      reportCurrentPlayer();
   }

   //    .
   synchronized public void finishSession() {
      //  ǾǷ ÷(onSession) Ѵ.
      onSession = false;
      endedPlayer = 0;

      //  Ǿٴ ޽ .
      String message = "650|*|FINISHSESSION";
      broadcastMessage(message);

      // и ʱȭ Ѵ.
      clearPae();

      //  ġ    ʱȭ Ѵ.
      sessionManScore[0] = 0;
      sessionManScore[1] = 0;
      sessionManScore[2] = 0;

      //   Ʈ ÷̾  .
      // ׸ ٽ STARTGO ޽ ޴´.
      sessionManList.removeAllElements();
   }

   //  Ŭ̾Ʈ ⸦ ٸ  ƴ϶..
   // Ŭ̾Ʈ ٽ  Ǵ STARTGO ޽  ûѴ.
   synchronized public void waitingSession() {
      String message = "650|*|WAITINGSESSION";
      broadcastMessage(message);

      try {
         //   , ÷̾   ֵ ٸ..
         Thread.sleep(5000);
      } catch(InterruptedException e) {
      }

      message = "650|*|GO/DIE?";
      broadcastMessage(message);
   }

   //    ĥ  ˸ ޽ .
   public void reportCurrentPlayer() {
      String message=null;
      GServerPlayer player=null;

      //  ġ ִ    ̻ 
      //  ġ ̹Ƿ
      if(sessionManList.size() >= SESSION_MAN_NUMBER) {
         //  ġ ÷̾ ߿  ĥ ÷̾ ´.
         player = (GServerPlayer)sessionManList.elementAt(currentPlayer);
         message = "650|"+player.id+"|TURN|"+player.id; // 6xx|xxx|xxx...

         //  ĥ  εĳ Ѵ.
         broadcastMessage(message);
      }
   }

   //  뿡 ִ    Ȳ ˸.
   // ׷ν     Ȳ   ֵ Ѵ.
   void reportLive() {
      GServerPlayer player=null;

      for(int i=0;i<playerList.size();i++) {
         player = (GServerPlayer)playerList.elementAt(i);
         if(!sessionManList.contains(player)) {
            //  ġ  ʴ 鿡Ը   Ȳ ߰ Ѵ.
            reportLive(player);
         }
      }
   }

   // ־ ÷̾  Ȳ ߰ Ѵ.
   public void reportLive(GServerPlayer player) {
      int pae=0;
      String message=null;

      // ٴ Ʈ 
      if(badakPaeList.size() > 0) {
         message = "680|*|$$ٴ$$|";
         for(int i=0;i<badakPaeList.size();i++) {
            pae = ((Integer)badakPaeList.elementAt(i)).intValue();
            message += pae + ",";
         }
         if(message.endsWith(",")) {
            message = message.substring(0, message.length()-1);
         }
         player.sendMessage(message);
      }

      // ù°   Ʈ 
      int index = ((winnerPlayer+0) % SESSION_MAN_NUMBER);
      if(index < sessionManList.size()) {
         if(playerPaeList[0].size() > 0) {
            // ޽ Ѵ.
            message = "680|*|"+((GServerPlayer)sessionManList.elementAt(index)).id+"|";
            for(int i=0;i<playerPaeList[0].size();i++) {
               pae = ((Integer)playerPaeList[0].elementAt(i)).intValue();
               message += pae + ",";
            }
            //  ߰ ',' Ѵ.
            if(message.endsWith(",")) {
               message = message.substring(0, message.length()-1);
            }
            // ־ ÷̾ ޽ .
            player.sendMessage(message);
         }
      }

      // ι°   Ʈ 
      index = ((winnerPlayer+1) % SESSION_MAN_NUMBER);
      if(index < sessionManList.size()) {
         if(playerPaeList[1].size() > 0) {
            // ޽ Ѵ.
            message = "680|*|"+((GServerPlayer)sessionManList.elementAt(index)).id+"|";
            for(int i=0;i<playerPaeList[1].size();i++) {
               pae = ((Integer)playerPaeList[1].elementAt(i)).intValue();
               message += pae + ",";
            }
            //  ߰ ',' Ѵ.
            if(message.endsWith(",")) {
               message = message.substring(0, message.length()-1);
            }
            // ־ ÷̾ ޽ .
            player.sendMessage(message);
         }
      }

      // °   Ʈ 
      index = ((winnerPlayer+2) % SESSION_MAN_NUMBER);
      if(index < sessionManList.size()) {
         if(playerPaeList[2].size() > 0) {
            // ޽ Ѵ.
            message = "680|*|"+((GServerPlayer)sessionManList.elementAt(index)).id+"|";
            for(int i=0;i<playerPaeList[2].size();i++) {
               pae = ((Integer)playerPaeList[2].elementAt(i)).intValue();
               message += pae + ",";
            }
            //  ߰ ',' Ѵ.
            if(message.endsWith(",")) {
               message = message.substring(0, message.length()-1);
            }
            // ־ ÷̾ ޽ .
            player.sendMessage(message);
         }
      }
   }

   // ־ ޽    鿡 εĳ Ѵ.
   public void broadcastMessage(String message) {
      GServerPlayer player=null;

      if(message == null) {
         return;
      }

      for(int i=0;i<playerList.size();i++) {
         player = (GServerPlayer)playerList.elementAt(i);

         player.sendMessage(message);
      }
   }

   //  ġ ִ 鿡 ޽ .
   public void sessioncastMessage(String message) {
      GServerPlayer player=null;

      for(int i=0;i<sessionManList.size();i++) {
         player = (GServerPlayer)sessionManList.elementAt(i);
         player.sendMessage(message);
      }
   }

   // и ̵Ų.
   //  , ٴڿ ִ и Ư ÷̾ Ծų, ⸮ и   
   // и  ִ Ϳ ٸ ͷ и ̵־ Ѵ.
   public void applyExchangePae(String fromId, String toId, String paeList) {
      Vector fromVector=null, toVector=null;

      // 𿡼 ű°?
      if("$$ٴ$$".equals(fromId)) {
         fromVector = badakPaeList;
      } else if("$$⸮$$".equals(fromId)) {
         fromVector = giriPaeList;
      } else if("$$$$".equals(fromId)) {
         fromVector = null;
      } else if(((GServerPlayer)sessionManList.elementAt(0)).id.equals(fromId)) {
         fromVector = playerPaeList[0];
      } else if(((GServerPlayer)sessionManList.elementAt(1)).id.equals(fromId)) {
         fromVector = playerPaeList[1];
      } else if(((GServerPlayer)sessionManList.elementAt(2)).id.equals(fromId)) {
         fromVector = playerPaeList[2];
      }

      //  ű°?
      if("$$ٴ$$".equals(toId)) {
         toVector = badakPaeList;
      } else if("$$⸮$$".equals(toId)) {
         toVector = giriPaeList;
      } else if("$$$$".equals(toId)) {
         toVector = null;
      } else if(((GServerPlayer)sessionManList.elementAt(0)).id.equals(toId)) {
         toVector = playerPaeList[0];
      } else if(((GServerPlayer)sessionManList.elementAt(1)).id.equals(toId)) {
         toVector = playerPaeList[1];
      } else if(((GServerPlayer)sessionManList.elementAt(2)).id.equals(toId)) {
         toVector = playerPaeList[2];
      }

      try {
         //  Ʈ(paeList)  ִ и ϳ
         //   Ʈ(fromVector) ٸ  Ʈ(toVector) ű.
         StringTokenizer tokenizer = new StringTokenizer(paeList, ",");
         while(tokenizer.hasMoreTokens()) {
            int paeId = 0;
            try {
               paeId = Integer.parseInt(tokenizer.nextToken());
            } catch(NumberFormatException e) {
               System.out.println(e);
               e.printStackTrace();
               continue;
            }
            Integer intObj=null;
            if(fromVector != null) {
               for(int i=0;i<fromVector.size();i++) {
                  intObj = (Integer)fromVector.elementAt(i);
                  if(intObj.intValue() == paeId) {
                     fromVector.removeElement(intObj);
                  }
               }
            }
            if(toVector != null) {
               toVector.addElement(new Integer(paeId));
            }
         }
      } catch(Exception ee) {
      }
   }

   //    ٵμ
   // 뿡 ִ Ŭ̾Ʈ(÷̾) ϱ   
   // 뿡   ִ Ŭ̾Ʈ    ൵ Ѵ.
   public void run() {
      GServerPlayer player=null;
      int pae=-1;

      //    ü   Ŭ̾Ʈ Ʈ ϵǾ ִ 
      // Ŭ̾Ʈκ  ޽ ֱ üũϿ о´.
      // , μ ϸ, ѷ ´.
      while(true) {
         // Read Data
         try {
            // CPU (Ǵ )ϴ 尡 Ǵ  ϱ  
            // ̸ ش.
            Thread.sleep(50);
         } catch(InterruptedException ie) {
         }

         // Ŭ̾Ʈ Ʈ ϵǾ ִ Ŭ̾Ʈ ü ϳ 
         //  chatList ؽ̺κ Enumeration ü ´.
         for(int i=0;i<playerList.size();i++) {
            // Enumeration üκ ϳ Ŭ̾Ʈ ü ´. 
            player = (GServerPlayer)playerList.elementAt(i);
            try {
               String receive = null;

//  Ŭ̾Ʈκ ͸ о´.
//  ,  Ŭ̾Ʈκ Ͱ  
//  ٸ(ŷ)  ƴ϶
// SO_TIME   ð(10msec) 
// Ͽ о̱  ŷ    ȴ.
// ׷,  Ŭ̾Ʈκ ͸ о  ִ.
               receive = player.receiveMessage();

// player.receiveMessage() ޼ҵ    .
//   1) Ŭ̾Ʈ  : SocketException or IOException  ߻
//                              try {
//                                 ...
//                              } catch(SocketException e) {
//                                  κп ش  ó
//                                   - Ʈ Ѵ.
//                              } catch(IOException e) {
//                                  κп ش  ó
//                                   - Ʈ Ѵ.
//                              }
//   2) null Ǵ ""  : Ŭ̾Ʈκ  Ͱ ų
//                            Ǵ, SO_TIME  ð  
//   3) ڿ : Ŭ̾Ʈκ  ͸  

//     쿡  óϴ ̴.

// 1)   ó  Ʒ ִ catch(...)  óѴ.
// 2) Ŭ̾Ʈκ ޵ Ͱ  
               if(receive == null || "".equals(receive)) {
                  continue;
               }

// 3) Ŭ̾Ʈκ ͸  о 
//     ݿ  ͸ óѴ.

               // Godori Protocol
               // nnn|arg1|arg2|arg3|...
               StringTokenizer st = new StringTokenizer(receive, "|");
               String command = st.nextToken();
               String message=null;
               if(command != null) {
                  if(command.startsWith("500")) {
                     // Commmand: 500|fromId|*|chatMessage
                     String fromId = st.nextToken();
                     String toId=st.nextToken();
                     String chatStr = st.nextToken();

                     message = "600|"+fromId+"|*|["+fromId+"] "+chatStr;
                     broadcastMessage(message);
                  } else if(command.startsWith("501")) {
                     // Commmand: 501|fromID|*|enter
                     String fromId = st.nextToken();

                     player = getPlayer(fromId);
                     if(player != null) {
                        message = "601|"+fromId+"*|enter";
                        broadcastMessage(message);

                        if((onSession == false)||
                           (sessionManList.size() < SESSION_MAN_NUMBER)) {
                           message = "650|*|JOINSESSION";
                           //   ֵ JOIN ư Ȱȭ Ѵ..
                           player.sendMessage(message);
                        }
                     }
                     informPlayerList();
//                     informPlayerList(player);
                  } else if(command.startsWith("502")) {
                     // Commmand: 502|fromID|*|join
                     //  īƮ Ͽ,
                     // 3 ̻ Ǹ    
                     //  3 Ŭ  GO/STOP θ ´.
                     //  3̸, ٷ  Ѵ.
                     String fromId = st.nextToken();
                     player = getPlayer(fromId);

                     if(player != null) {
                        if((!participantList.contains(player))&&
                           (participantList.size() < PARTICIPANT_NUMBER)) {
                           participantList.addElement(player);

                           if((!sessionManList.contains(player))&&
                              ((onSession == false)||
                               (sessionManList.size() < SESSION_MAN_NUMBER))) {
                              sessionManList.addElement(player);
                              message = "6"+receive.substring(1); // 6xx|xxx|xxx...
                              broadcastMessage(message);

                              if(sessionManList.size() == SESSION_MAN_NUMBER) {
                                 startSession();
                              }
                           }
                           if (onSession == true) { //duke
                              message = "606|" + fromId
                                      + "|  Դϴ."
                                      + " ø ٸ.";
                              player.sendMessage(message);
                           }
                        } else {
                           if(participantList.size() >= PARTICIPANT_NUMBER) {
                              message = "606|"+fromId+"| áϴ.";
                              player.sendMessage(message);
                           }
                        }
                     }
                     informPlayerList();
                  } else if(command.startsWith("504")) {
                     // Commmand: 504|fromID|*|exit
                     String fromId = st.nextToken();

                     player = getPlayer(fromId);
                     if(player != null) {
                        if(onSession == true && sessionManList.contains(player)) {
                           message = "606|"
                                   + fromId
                                   + "| ġ ߿"
                                   + "    ϴ.";
                           player.sendMessage(message);
                        } else {
                           if(sessionManList.contains(player)) {
                              sessionManList.removeElement(player);
                           }
                           if(participantList.contains(player)) {
                              participantList.removeElement(player);
                           }
                           removePlayer(player);

                           message = "6"+receive.substring(1); // 6xx|xxx|xxx...
                           broadcastMessage(message);
                        }
                     }
                     informPlayerList();
//                     informPlayerList(player);
                  } else if(command.startsWith("510")||  
                            // Commmand: 510|fromID|$$ٴ$$|1,2,...
                            command.startsWith("512")||  
                            // Commmand: 512|$$ٴ$$|toID|1,2,...
                            command.startsWith("514")||
                            // Commmand: 514|fromID|toID|1,2,...
                            command.startsWith("516")||
                            // Commmand: 516|$$⸮$$|$$ٴ$$|1,2,...
                            command.startsWith("518")||
                            // Commmand: 518|$$⸮$$|$$$$|1,2,...
                            command.startsWith("520")) {
                            // Commmand: 520|$$$$|[toId|$$ٴ$$]|1,2,...

                     String fromId = st.nextToken();
                     // It should be "$$$$".
                     String toId = st.nextToken();
                     // It should be toId or "$$ٴ$$".
                     String paeList = st.nextToken();

                     // бȯ (⸮->NONE) ó
                     applyExchangePae(fromId, toId, paeList);

                     // Ŭ̾Ʈ ޽ 
                     message = "6"+receive.substring(1); // 6xx|xxx|xxx...
                     sessioncastMessage(message);

                     reportLive();
                  } else if(command.startsWith("532")) {
                     // Commmand: 532|fromId
                     // Description:  Ʈ û
                     String fromId = st.nextToken();

                     player = getPlayer(fromId);
                     if(player != null) {
                        informPlayerList(player);
                     }
                  } else if(command.startsWith("560")) {
                     //    Commmand: 560|fromId|FINISHSESSION
                     //    Commmand: 560|fromId|STARTGO
                     //    Commmand: 560|fromId|STARTDIE
                     //    Commmand: 560|fromId|FINISHPUT
                     //    Commmand: 560|fromId|ONGO|goCount|score
                     //    Commmand: 560|fromId|ONSTOP|[score|"SSAM"]
                     //    Commmand: 560|fromId|END|score
                     //    Commmand: 560|fromId|SCORE|score
                     //    Commmand: 560|fromId|POINT|point
                     //    Commmand: 560|fromId|SSAM|ssamCount
                     //    Commmand: 560|fromId|WINNER|point|DOUBLE_MSG
                     //    Commmand: 560|fromId|LOSER|point|DOUBLE_MSG
                     //    Commmand: 560|fromId|DOKBAK|point|DOUBLE_MSG
                     //    Commmand: 560|fromId|SOUND|type=["STRIKE" |
                     //                                     "WINNER" |
                     //                                     "LOSER" |
                     //                                     "SSAM" |
                     //                                     "GO" |
                     //                                     "STOP" |
                     //                                     "SHAKE" ]
                     //    Commmand: 560|fromId|DOUBLE||
                     String fromId = st.nextToken();
                     String type = st.nextToken();

                     if("FINISHSESSION".equals(type)) {
                        // Ŭ̾Ʈ ޽    ó ..

                        finishSession();
                        /*
                         * ϴ,   ٽ ϵ Ѵ.
                         *  ޽ Ŭ̾Ʈ   ư
                         *  ʾ    Ѵ.
                         */
                        waitingSession();
/*
                        startSession();
*/

                        message = "6"+receive.substring(1); // 6xx|xxx|xxx...
                        broadcastMessage(message);
                     } else if("STARTGO".equals(type)) {
                        //  ġ(GO) ó
                        //   -   īƮ ,
                        //       īƮ 3 Ǹ   ġ
                        message = "6"+receive.substring(1); // 6xx|xxx|xxx...
                        broadcastMessage(message);

                        player = getPlayer(fromId);
                        if(player != null) {
                           if((!sessionManList.contains(player))&&
                              (sessionManList.size() < SESSION_MAN_NUMBER)) {
                              sessionManList.addElement(player);
                           }
                           if(sessionManList.size() == SESSION_MAN_NUMBER) {
                              startSession();
                           }
                        }
                        informPlayerList();
                     } else if("STARTDIE".equals(type)) {
                        //  ױ(GO) ó - ʿ ǹ ???
                        message = "6"+receive.substring(1); // 6xx|xxx|xxx...
                        broadcastMessage(message);

                        informPlayerList();
                     } else if("FINISHPUT".equals(type)) {
                        //      FINISHPUT
                        currentPlayer = (currentPlayer + 1) % SESSION_MAN_NUMBER;
/*
                        player = (GServerPlayer)
                                      sessionManList.elementAt(currentPlayer);
                        message = "650|"+player.id+"|TURN|"+player.id;
                        // 6xx|xxx|xxx...
                        broadcastMessage(message);
*/
                        reportCurrentPlayer();
                     } else if("ONGO".equals(type)) {
                        // GO ó - 1, 2, 3  ó
                        //           GO    ,
                        //           Ͽ  GO īƮ ϰ,
                        //          ٸ ó
                        String goCount = st.nextToken();
                        String score = st.nextToken();

                        message = "6"+receive.substring(1); // 6xx|xxx|xxx...
                        broadcastMessage(message);
                     } else if("ONSTOP".equals(type)) {
                        // STOP ó - ڰ ,
                        //                  
                        //              ƴ     Ҿ
                        //             ִ ̾α ڽ ǥ

                        // : 606|ID|¸Ͽϴ.    ϴ.
                        // : 606|ID|Ͽϴ.    Ҿϴ.

                        //  ϱ
                        winnerPlayerId = fromId;
                        winnerPlayer = currentPlayer;

                        String score = st.nextToken();

                        message = "6"+receive.substring(1); // 6xx|xxx|xxx...
                        broadcastMessage(message);
                     } else if("DOUBLE".equals(type)) {
                        //    Commmand: 560|fromId|DOUBLE||
/*
                        String doubleItems = st.nextToken();

                        int doubleScore=1;
                        try {
                           StringTokenizer tokenizer
                                        = new StringTokenizer(doubleItems, ",");
                           while(tokenizer.hasMoreTokens()) {
                              doubleScore *= 2;
                           }
                        } catch(Exception ee) {
                        }
*/
                        message = "6"+receive.substring(1); // 6xx|xxx|xxx...
                        broadcastMessage(message);
                     } else if("SCORE".equals(type)) {
                        //    Commmand: 560|fromId|SCORE|score

                        String score = st.nextToken();

                        player = getPlayer(fromId);
                        if((player != null)&&(sessionManList.contains(player))) {
                           int index = sessionManList.indexOf(player);
                           sessionManScore[index] = Integer.parseInt(score);
                        }

                        message = "6"+receive.substring(1);
                        // 660|fromId|SCORE|score
                        broadcastMessage(message);
                     } else if("POINT".equals(type)) {
                        //    Commmand: 560|fromId|POINT|point

                        message = "6"+receive.substring(1);
                        // 660|fromId|WINNER|point|DOUBLE_MSG
                        broadcastMessage(message);
                     } else if("SSAM".equals(type)) {
                        //    Commmand: 560|fromId|SSAM|paeNo|ssamCount

                        message = "6"+receive.substring(1);
                        // 660|fromId|SSAM|paeNo|ssamCount
                        broadcastMessage(message);
                     } else if("FIRSTSSAM".equals(type)) {
                        //    Commmand: 560|fromId|FIRSTSSAM|pae

                        message = "6"+receive.substring(1);
                        // 660|fromId|FIRSTSSAM|pae
                        broadcastMessage(message);
                     } else if("WINNER".equals(type)) {
                        //    Commmand: 560|fromId|WINNER|point|DOUBLE_MSG

                        message = "6"+receive.substring(1);
                        // 660|fromId|LOSER|point|DOUBLE_MSG
                        broadcastMessage(message);
                     } else if("LOSER".equals(type)) {
                        //    Commmand: 560|fromId|LOSER|point|DOUBLE_MSG

                        message = "6"+receive.substring(1);
                        // 660|fromId|POINT|point
                        broadcastMessage(message);
                     } else if("DOKBAK".equals(type)) {
                        //    Commmand: 560|fromId|DOKBAK|point|DOUBLE_MSG

                        message = "6"+receive.substring(1);
                        // 660|fromId|POINT|point
                        broadcastMessage(message);
                     } else if("SOUND".equals(type)) {
                        //    Commmand: 560|fromId|SOUND|type=["STRIKE" |
                        //                                     "WINNER" |
                        //                                     "LOSER" |
                        //                                     "SSAM" |
                        //                                     "GO" |
                        //                                     "STOP" |
                        //                                     "SHAKE"]

                        message = "6"+receive.substring(1);
                        // 660|fromId|SOUND|type
                        broadcastMessage(message);
                     } else if("ANIMATEPUT".equals(type)) {
                        //    Commmand: 560|fromId|ANIMATEPUT|paeId,x,y,c

                        message = "6"+receive.substring(1);
                        // 660|fromId|ANIMATEPUT|paeId,x,y,c
                        broadcastMessage(message);
                     } else if("END".equals(type)) {
                        //    Commmand: 560|fromId|END|score
                        String score = st.nextToken();

                        message = "6"+receive.substring(1);
                        // 660|fromId|SCORE|score
                        broadcastMessage(message);

                        endedPlayer++;
                        if(endedPlayer == 3) {
                           onSession = false;
                           finishSession();
                           waitingSession();
/*
                           startSession();
*/
                        }
                     } else {
//                        System.out.println("COMMAND 560 (2) ERROR: ["
//                                          + fromId + "," + type + "]");
                     }
                  } else if(command.startsWith("580")) {
                     // Commmand: 582|fromId
                     // Description:  Ǵ  Ʈ û
                     String fromId = st.nextToken();

                     if(onSession == true) {
                        player = getPlayer(fromId);
                        reportLive(player);
                     }
                  } else if(command.startsWith("584")) {
                     // Commmand: 584|fromId
                     // Description:  Ʈ û
                     String fromId = st.nextToken();

                     try {
                        if(player.lobby.chatList.size() > 0) {
                           message = "684|"+fromId+"||";
                           //   
                           Enumeration e = player.lobby.chatList.elements();
                           while(e.hasMoreElements()) {
                              player = (GServerPlayer)e.nextElement();
                              message += player.id + ",";
                           }
                           if(message.endsWith(",")) {
                              message = message.substring(0, message.length()-1);
                           }
                        } else {
                           message = "688|none|"+fromId+"||EMPTY";
                        }
                     } catch(Exception ee) {
                     }
                     player = getPlayer(fromId);
                     player.sendMessage(message);
                  } else if(command.startsWith("586")) {
                     // Commmand: 586|fromId|who
                     // Description: ClientLobby  ʴϱ û 
                     String fromId = st.nextToken();
                     String who = st.nextToken();

                     try {
                        // ClientLobby  ʴϱ û 
                        message = "486|"+fromId+"|"+who+"|";
                        //   
                        player = (GServerPlayer)player.lobby.chatList.get(who);
                        if(player != null) {
                           message += getPlayer(fromId).room.roomId;

                           player.sendMessage(message);
                        }
                     } catch(Exception ee) {
                        System.out.println("Invitation: "+ee);
                     }
                  }
               }
            } catch(SocketException e) { //Stream doesn't exist.
               // 1)    óѴ.
               // Ŭ̾Ʈ Ʈŷ  ̹Ƿ,
               // ݵ ش Ŭ̾Ʈ κ񿡼 ؾ Ѵ.
               removePlayer(player);
            } catch(IOException ne) {
               // 1)    óѴ.
               // Ŭ̾Ʈ Ʈŷ  ̹Ƿ,
               // ݵ ش Ŭ̾Ʈ κ񿡼 ؾ Ѵ.
               removePlayer(player);
            }
         }
      }
   }
}
