/*
 * Copyright (c) 2000 Yongwoo's Park. All Rights Reserved.
 */

package rndclub.game.godori;
import java.awt.*;
import java.awt.event.*;

// ˻   ֱ  ̾α â̴.
class ProfileDialog extends Dialog {
    Button okButton = null;
    Label msgLabel = null;
    Label idLabel=null, pointLabel=null, sexLabel=null, ageLabel=null;
    Label totalLabel=null, winLabel=null, loseLabel=null;
    Label positionLabel=null, finishLabel=null;

    public ProfileDialog(Frame owner, String title, String message,
                         String id, String point, String sex, String age,
                         String total, String win, String lose, String position) {
      super(owner, title, true);
      setLayout(new BorderLayout());
      setBackground(new Color(131,131,131));
      msgLabel = new Label(message);
      msgLabel.setAlignment(Label.CENTER);
      msgLabel.setForeground(Color.blue);

      okButton = new Button("Ȯ");
      okButton.setBackground(new Color(184,184,218));

      Panel p2 = new Panel(new GridLayout(7,1));
      p2.setBackground(new Color(131,131,131));

      // ˻ 밡  ,  ش.
      if(!"**^____^**".equals(message)) {
         idLabel = new Label("ID: " +id,Label.LEFT);
         pointLabel = new Label("POINT: "+point,Label.LEFT);
         sexLabel = new Label(" :"+sex,Label.LEFT);
         ageLabel = new Label(": "+age,Label.LEFT);
         totalLabel = new Label(": "+total+" "+win+" "+lose+"",Label.LEFT);
         positionLabel = new Label(" ̸: "+position,Label.LEFT);
         finishLabel = new Label("˻ ̷!",Label.CENTER);

         p2.add(idLabel);
         p2.add(pointLabel);
         p2.add(sexLabel);
         p2.add(ageLabel);
         p2.add(totalLabel);
         p2.add(positionLabel);
         p2.add(finishLabel);
      } else {
         idLabel = new Label("["+id+"]   ʽϴ.", Label.CENTER);
         p2.add(idLabel);
      }

      Panel p = new Panel();
      p.setBackground(new Color(235,235,206));
      p.add(okButton);

      add("North",msgLabel);
      add("Center",p2);
      add("South",p);

      // "OK" ư Ŭϸ ̾α â ݰ .
      okButton.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            dispose();
         }
      });

      //  ݱ ư Ŭϸ ̾α â ݰ .
      addWindowListener(new WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            dispose();
         }
      });

      pack();        // ̾α â ũ⸦  ũ Ѵ.
      autoAlign();   // ̾α â ũ ߾ ġŲ.

      // ̾α â Ÿ ¿ ٷ Ű ĵ
      // ̾α â ݰ   ֵ "OK" ư 
      // Է Ŀ ش.
      okButton.requestFocus();
   }

   // ̾α â ũ ߾ ġŲ.
   public void autoAlign() {
      int sw = Toolkit.getDefaultToolkit().getScreenSize().width;
      int sh = Toolkit.getDefaultToolkit().getScreenSize().height;
      int dw = getSize().width;
      int dh = getSize().height;
      int x = (((sw - dw) / 2) < 0) ? 0 : ((sw - dw) / 2);
      int y = (((sh - dh) / 2) < 0) ? 0 : ((sh - dh) / 2);

      setLocation(x, y);
   }
}

