package org.rndclub.godori;

/*
 * Copyright (c) 2000 Yongwoo's Park. All Rights Reserved.
 */

import java.net.*;
import java.io.*;

/*
 * Ʈũ   α׷( ø̼) ϸ,
 * Ŭ̾Ʈ ó  , ̸ óϱ   Ŭ̴.
 * Ŭ̾Ʈ GODORI_PORT(=4001) Ʈ ϸ
 *  Ŭ̾Ʈ Ʈŷ  GServerPlayer ü Ѵ.
 */
public class PpiKki extends Thread {
   public static final int GODORI_PORT = 4001;         // PORT 4001
   Lobby lobby=null;

   int port=4001;
   ServerSocket ppikkiSocket=null;

   //  ø̼ α׷ main() ޼ҵ
   public static void main(String args[]) {
      System.out.println("Godori Server up and running...");
      System.out.println("Godori Pae Initializing.........");

      // PpiKki ü( ü) Ѵ.
      PpiKki ppikki = new PpiKki(GODORI_PORT);

      // 带 Ѵ. 
      //  start() ޼ҵ带 ȣϸ
      //  ڵ run() ޼ҵ尡 ȣȴ.
      ppikki.start();
   }

   // PpiKki Ŭ ü 
   public PpiKki(int port) {
      try {
         // ־ Ʈ Ʈũ û ٸ
         //  (ServerSocket ü) Ѵ.
         this.port = port;
         ppikkiSocket = new ServerSocket(this.port);

         System.out.println("GServer listening on " + GODORI_PORT + " PORT");
      } catch (IOException e) {
         System.out.println("Couldn't access port " + GODORI_PORT + "PORT");
         System.exit(1);
      }

      // Ŭ̾Ʈ ó Ͽ Ʈũ  Ǹ,
      // PpiKki 忡 (Lobby ü ) ѱ.
      // ,  ǿ Ʈŷ ϴ μ Ѵ.
      lobby = new Lobby(); // Ʈũ   带 ϳ 
      lobby.start();       // ǿ Ʈŷ    
   }

   // PpiKki  ٵ
   public void run() {
      Socket socket=null;
      GServerPlayer player=null;

      System.out.println("Lobby thread is started...");
      while(true) {
         try {
            // GODORI_PORT(=4001) Ŭ̾Ʈ  ٸ.
            // listening...
            //  , accept() ޼ҵ忡 Ŭ̾Ʈ ϸ
            // ش Ŭ̾Ʈ Ʈŷ  Socket ü  ش.
            socket = ppikkiSocket.accept();
            if(socket == null) {
               continue;
            } else {
               // ־ socket ü Ʈŷ  GServerPlayer ü 
               // (socket),   (lobby),  (null) ...
               //  , GServerPlayer ü Ŭ̾Ʈ Ǵ ÷̾ Ѵ.
               player = new GServerPlayer(socket, lobby, null);
               if(player == null) {
                  System.out.println("PLAYER is null");
                  continue;
               }
            }
            // Ŭ̾Ʈ Ʈũ  Ŭ̾Ʈ ´ üũ
            player.validation();

            //  Ŭ̾Ʈ  Ʈ .
            lobby.sendRoomList(player.id);

            //  Ŭ̾Ʈ κ ÷̾ Ʈ ߰Ѵ.
            lobby.addPlayer(player);

            // κ  Ʈ ü ٽ .
            lobby.broadcastRoomList();

            // ÷̾  ŸӾƿ(SO_TIMEOUT) 10msec Ѵ.
            // Ϲ, Ͽ ͸ б  ŷ Ǵµ
            // SO_TIMEOUT ν ͸ б ŷ Ǿ,
            // ŸӾƿ ߻ϴ ŷ ¿  Ѵ.
            player.socket.setSoTimeout(10);
         } catch(Exception e) {
            e.printStackTrace();
         }
      }
   }
}
