package rndclub.game.hiddencatch;
import java.awt.*;

// ӿ    ֱ  ο Ʈ 
class LifeBar extends Canvas {
   final static int LIFE_WIDTH=16;  //  ̹ ʺ
   final static int LIFE_HEIGHT=16; //  ̹ 

   int life, maxLife;               //   , ü  
   Image lifeImage=null;            //  ̹

   public LifeBar(int maxLife) {
      this(maxLife, null);
   }

   public LifeBar(int maxLife, Image lifeImage) {
      this.maxLife = maxLife;
      this.lifeImage = lifeImage;

      setBackground(new Color(0x22, 0x22, 0x66));
      setSize(maxLife*LIFE_WIDTH, LIFE_HEIGHT);

      init();
   }

   public void init() {
      life = maxLife;   // ó   ִ.
   }

   //  Ÿ  ̹ /
   void setImage(Image lifeImage) {
      this.lifeImage = lifeImage;
      repaint();
   }

   // ִ   /
   void setLife(int life) {
      this.life = life;
      repaint();
   }

   // ִ  ŭ ҽŴ
   void decLife(int life) {
      this.life -= life;
      if(this.life < 0) {
         this.life = 0;
      }
      repaint();
   }

   //   ִ ˻
   boolean isAlive() {
      return(life != 0);
   }

   //  ϳ   ˻
   boolean isDead() {
      return(life == 0);
   }

   //  ִ  /
   void setMaxLife(int maxLife) {
      this.maxLife = maxLife;
      repaint();
   }

   // paint() ޼ҵ尡 ̺Ʈ  ȣ ʰ, ٷ ȣǵ ϱ 
   public void repaint() {
      update(getGraphics());
   }

   // update() ޼ҵ带 Ͽ ̴  
   public void update(Graphics g) {
      paint(g);
   }

   //    شϴ ȭ 
   public void paint(Graphics g) {
      if(g == null) return;

      // ִ ŭ  ׸
      for(int i=0;i<life;i++) {
         g.drawImage(lifeImage, i*LIFE_WIDTH, 0, LIFE_WIDTH, LIFE_HEIGHT, this);

         g.setColor(Color.black);
         g.drawRect(i*LIFE_WIDTH, 0, LIFE_WIDTH, LIFE_HEIGHT);
      }

      //    ä
      for(int i=life;i<maxLife;i++) {
         g.setColor(getBackground());
         g.fillRect(i*LIFE_WIDTH, 0, LIFE_WIDTH, LIFE_HEIGHT);
         g.setColor(Color.black);
         g.drawRect(i*LIFE_WIDTH, 0, LIFE_WIDTH, LIFE_HEIGHT);
      }
   }
}
