import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

public class AppletTetris extends Applet implements ActionListener {
//   Display disp;
   private Button cmdNew=null;
   private Button cmdExit=null;

   MineCanvas canvas=null;

   public void init() {
      setLayout(new BorderLayout());
//      setBackground(Color.blue);
      cmdNew = new Button("New");
      cmdExit = new Button("Exit");
      canvas = new MineCanvas();

      Panel  tetrisPanel = new Panel();
      tetrisPanel.add(canvas);

      Panel  commandPanel = new Panel();
      commandPanel.add(cmdNew);
      commandPanel.add(cmdExit);

      add("Center", tetrisPanel);
      add("South", commandPanel);

      cmdNew.addActionListener(this);
      cmdExit.addActionListener(this);

      canvas.requestFocus();
   }

   public void start() {
//      canvas = new MineCanvas(disp);

      canvas.start();
//      canvas.addCommand(cmdExit);
//      canvas.addCommand(cmdNew);
//      canvas.setCommandListener(this);
   }

   public void stop() {
   }

   public void destroy() {
   }

   public void actionPerformed(ActionEvent e) {
      if(e.getSource() == cmdExit) {
         // destroyApp(false);
         // notifyDestroyed();
      } else if(e.getSource() == cmdNew) {
         canvas.newGame();
      }
      canvas.requestFocus();
   }	
}
