package rndclub.game.mobiletetris;
import java.util.*;
import javax.microedition.lcdui.*;

public class Block {
   int	x, y, c, cols, rows;

   public Block(int x, int y, int c, int cols, int rows) {
      this.x = x;
      this.y = y;
      this.cols = cols;
      this.rows = rows;
      this.c = c;
   }

   int getX() {
      return x; 
   }

   int getY() {
      return y; 
   }

   int getColor() { 
      return c; 
   }

   boolean inBounds() {
      return((x >= 0)&&(x < this.cols)&&(y >= 0)&&(y < this.rows+4));
   }

   boolean isEqual(Block s) {
      return((x == s.x)&&(y == s.y)&&(c == s.c));
   }
}
