package rndclub.game.snowcraft;

// Level Up (1~3ܰ)	1999.11.25. 
// Level 1 :  3, sleeptime = sleeptime * speed speed = 1.5
// Level 2 :  5, sleeptime = sleeptime * speed speed = 1
// Level 3 :  7, sleeptime = sleeptime * speed speed = 0.5

//  add functions
// levelUp()
// levelUpCheck()

// add instances
// audioclip....
// mousepoint change
// image create
// levelUp....... speed, etc 

import java.awt.*;
import java.awt.event.*;
import java.applet.*;  // added for AudioClip

import java.io.*;
import java.net.*;
import java.util.*;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

public class SnowCraft extends Applet implements Runnable, MouseListener, MouseMotionListener {
   int[] type = new int[] { Cursor.CROSSHAIR_CURSOR };
   Cursor cursor;

   AudioClip audioClip, levelClip, strikeClip, astrikeClip, endClip, notcomeClip, shootClip;
   AudioClip deadClip, adeadClip, dropClip, ashootClip;	

   final static int MS  =   3;
   final static int BSD =  10;
   final static int DISPLAY_DELAY =  50;
   final static int DISPLAY_COMPUTING = 100;

   int paintMode=0;

   int totalImages1 = 4, totalImages2 = 8;

   int level = 1;	//level 1 3    
   int AMS = 3;		//level 1,2,3   : 3, 5, 7  
   int count=0;		// Ʊ  üũ 
   int acount=0;	//   üũ  
   long speed = (long)1.5;	//level 1, 2, 3 sleeptime   

   int xpos[]={0, 0, 0};
   int ypos[]={0, 0, 0};
   int axpos[]={75,  225, 150,  10, 230,  50, 125};
   int aypos[]={110, 50,  100, 150,  10,  75,   25};   
   int dx, dy, who, width, height;

   int status[]={0, 0, 0};
   int aicom[]= {0, 0, 0, 0, 0, 0, 0};
   int astatus[]={0, 0, 0, 0, 0, 0, 0};
   int aenergy[]={3, 3, 3, 3, 3, 3, 3};
   int energy[]={2, 2, 2};
   int agetUp[]={0, 0, 0, 0, 0, 0, 0};

   int tempx[], tempy[];
   int comdir[]={0, 0, 0, 0, 0, 0, 0};

   int comdir2[]={0, 0, 0, 0, 0, 0, 0};   
   int tx, ty1, ty2, power=1;

   Vector vx, vy, vz;
   Vector avx, avy, avz;
   Graphics bufferGraphics;

   Image bufferImage, bg, ball, shadow, burst, images1[], images2[];

   MediaTracker imageTracker;

   Thread displayThread, computerActionThread;

   boolean first = true;

   MediaTracker tracker=null;
   Toolkit tk=null;
   Image logoImage=null;

   LoadingBarWindow loadingBarWindow=null;
   int loadingBarCount = 0;

   public void init() {
      cursor = Cursor.getPredefinedCursor(type[0]);
      this.setCursor(cursor);

      logoImage = getImage(getDocumentBase(), "images/logo.jpg");
      if(tracker == null) {
         tracker = new MediaTracker(this);
      }
      tracker.addImage(logoImage, 0);
      try {
         tracker.waitForAll();
      } catch(InterruptedException e) {
//         System.out.println(e);
      }

System.out.println("this: "+this);
System.out.println("this.getParent(): "+this.getParent());
System.out.println("this.getParent().getParent(): "+this.getParent().getParent());

      loadingBarWindow = new LoadingBarWindow(logoImage, "loading images...");
      loadingBarWindow.show();

      loadingBarWindow.setMessage("loading images...");
      loadingBarWindow.setStatusLevel(0);
      loadImages();

      loadingBarWindow.setMessage("loading sounds...");
      loadingBarWindow.setStatusLevel(0);
      loadSounds();

      loadingBarWindow.dispose();

      vx=new Vector(); vy=new Vector(); vz=new Vector();
      avx=new Vector(); avy=new Vector(); avz=new Vector();
      tempx = new int[MS];
      tempy = new int[MS];

      bufferImage = createImage(this.size().width, this.size().height);
      bufferGraphics = bufferImage.getGraphics();

      width = images1[0].getWidth(this);
      height = images1[0].getHeight(this);

      addMouseListener(this);
      addMouseMotionListener(this);
   }

   private void getImagesFromZip() {
      try {
         ZipInputStream zipInputStream=null;
         ZipEntry zipEntry=null;
         URL url = new URL(getDocumentBase(), "images/images.zip");

//System.out.println("URL: "+url);

         zipInputStream = new ZipInputStream(new DataInputStream(url.openStream()));

         if(tk == null) {
            tk = Toolkit.getDefaultToolkit();
         }
         while((zipEntry = zipInputStream.getNextEntry()) != null) {
            String name = zipEntry.getName();
            int pos = 0;
            int bytesRead=0;
            int size = (int)zipEntry.getSize();
            byte[] buffer = new byte[size];
            for(;size>0;size-=bytesRead) {
               bytesRead = zipInputStream.read(buffer, pos, size);
               pos += bytesRead;
            }

            if("background.jpg".equals(name)) {
               bg = tk.createImage(buffer);
            } else if("shadow.gif".equals(name)) {
               shadow = tk.createImage(buffer);
            } else if("fall.gif".equals(name)) {
               burst = tk.createImage(buffer);
            } else if("ball.gif".equals(name)) {
               ball = tk.createImage(buffer);
            } else {
               boolean flag=true;
               for(int i=0;i<images1.length;i++) {
                  if(("sf"+(i+1)+".gif").equals(name)) {
                     images1[i] = tk.createImage(buffer);
                     flag = false;

                     break;
                  }
               }
               for(int i=0;(flag == true)&&(i<images2.length);i++) {
                  if(("asf"+(i+1)+".gif").equals(name)) {
                     images2[i] = tk.createImage(buffer);
                     break;
                  }
               }
            }
//System.out.println("Name: "+name);
            loadingBarCount++;
            int level = (int)(((double)loadingBarCount/16.0)*100.0);
            loadingBarWindow.setStatusLevel(level);
         }
      } catch(Exception anyException) {
         anyException.printStackTrace();
      }
   }

   private void loadImages() {
      if(tracker == null) {
         tracker = new MediaTracker(this);
      }
      try {
         images1 = new Image[totalImages1];
         images2 = new Image[totalImages2];

         getImagesFromZip();

         tracker.addImage(bg, 0);
         tracker.addImage(ball, 1);
         tracker.addImage(shadow, 1);
         tracker.addImage(burst, 1);
         for(int i=0;i<images1.length;i++) {
            tracker.addImage(images1[i], 2);
         }
         for(int i=0;i<images2.length;i++) {
            tracker.addImage(images2[i], 2);
         }
      } catch(Exception ex) {
//         System.out.println("Exception:"+ex);
      }
      try {
         tracker.waitForAll();
      } catch(Exception exception1) {
      }
   }

   public AudioClip getAudioClip(URL url, String name) {
      AudioClip clip = super.getAudioClip(url, name);

//System.out.print("Name: "+name);
      clip.play();   //  Ŭ ٿε   play ȴ.
//System.out.println(", Clip: "+clip);

      int level = (int)(((double)(++loadingBarCount) / (double)11) * (double)100);
      loadingBarWindow.setStatusLevel(level);

      clip.stop();   // ٷ ߰ ν Ҹ  ʰ Ѵ.

      return(clip);
   }

   private void loadSounds() {
      loadingBarCount = 0;

      audioClip = getAudioClip(getCodeBase(), "audio/audioclip.au");
      levelClip = getAudioClip(getCodeBase(), "audio/levelclip.au");
      shootClip = getAudioClip(getCodeBase(), "audio/shootclip.au");
      ashootClip = getAudioClip(getCodeBase(), "audio/ashootclip.au");
      astrikeClip = getAudioClip(getCodeBase(), "audio/astrikeclip.au");
      strikeClip = getAudioClip(getCodeBase(), "audio/strikeclip.au");
      //     amoveClip = getAudioClip(getCodeBase(), "amoveclip.au");
      notcomeClip = getAudioClip(getCodeBase(), "audio/notcomeclip.au");
      endClip = getAudioClip(getCodeBase(), "audio/endclip.au");
      deadClip=getAudioClip(getCodeBase(), "audio/deadclip.au");
      adeadClip=getAudioClip(getCodeBase(), "audio/adeadclip.au");
      dropClip=getAudioClip(getCodeBase(), "audio/dropclip.au");

      loadingBarWindow.setStatusLevel(100);
   }

   public void mouseClicked(MouseEvent e) { }
   public void mouseEntered(MouseEvent e) { }
   public void mouseExited(MouseEvent e) { }
   public void mouseMoved(MouseEvent e) { }

   public void mousePressed(MouseEvent e) {
      int x=e.getX();
      int y=e.getY();
      for(int i=0;i<MS;i++) {
         if(status[i] != 3) {
            dx = x - xpos[i];
            dy = y - ypos[i];
            if(dx < width && dx >= 0 && dy < height && dy >= 0) {
               status[i] = 1;
               who = i;
               break;
            }
         }
      }
   }

   public void mouseDragged(MouseEvent e) {
      if(status[who] != 3) {
         int x=e.getX();
         int y=e.getY();
         // if(amoveClip != null) amoveClip.play();         
         if((x+y)<=400) {
            if(notcomeClip != null) notcomeClip.play();
         }

         if(((x+y)>400)&&dx<width && dx >= 0 && dy < height && dy >= 0 && x < 582 && y < 312) {
            xpos[who] = x - dx;
            ypos[who] = y - dy;
            status[who] = 1;
         }
      }
   }

   public void mouseReleased(MouseEvent e) {   	
      if(status[who] != 3 && dx<width && dx>=0 && dy<height && dy>=0) {
         vx.addElement(new Integer(xpos[who]+5));
         vy.addElement(new Integer(ypos[who]+10));
         vz.addElement(new Integer(power/2));
         status[who] = 2;
      }
      power = 0;
   }

   public void start() {
      if(audioClip != null) audioClip.loop();

      if(displayThread == null) {
         displayThread = new Thread(this);
         displayThread.start();
      }
      if(computerActionThread == null) {
         computerActionThread = new Thread(this);
         computerActionThread.start();
      }
   }

   public void stop() {
      if(audioClip != null) audioClip.stop();
      if(strikeClip != null) strikeClip.stop();
      if(astrikeClip != null) astrikeClip.stop();   	    	 
      if(levelClip != null) levelClip.stop();
      if(endClip != null) endClip.stop();
      if(notcomeClip != null) notcomeClip.stop();
      if(shootClip != null) shootClip.stop();
      if(deadClip != null) deadClip.stop();
      if(adeadClip != null) adeadClip.stop();
      if(dropClip != null) dropClip.stop();
      if(ashootClip != null) ashootClip.stop();   

      if(displayThread != null) {
         displayThread.stop();
         displayThread = null;
      }
      if(computerActionThread != null) {
         computerActionThread.stop();
         computerActionThread = null;
      }
   }

   public void run() {
      Thread currentThread=null;

      while(true) {
         if(status[who] == 1 && power < 50) {
            power++;
         }
         currentThread = Thread.currentThread();
         if(currentThread == displayThread) {
            try {
               Thread.sleep(DISPLAY_DELAY);
            } catch(InterruptedException e) {
               showStatus(e.toString());
            };
            repaint();
         } else if(currentThread == computerActionThread) {
            try {
               Thread.sleep(DISPLAY_COMPUTING);
            } catch(InterruptedException e) {
               showStatus(e.toString());
            };
            computerAction();
         }
      }
   }

   public void tranject(int dirx, int diry, int dirz, int ith) {
      int check = 0;

      if(shootClip != null) {
         shootClip.play();
      }
      for(int i=0;i<AMS;i++) {
         if(astatus[i] != 6 && astatus[i] != 7) {	
            if(axpos[i]+10 < dirx && axpos[i]+35 > dirx &&
               aypos[i]+15 < diry && aypos[i]+36 > diry) {
               if(adeadClip != null) {
                  adeadClip.play();
               }
               if(astatus[i] != 6 && astatus[i] != 7) {
                  aenergy[i]--;
               }
               if(aenergy[i] != 0) {
                  astatus[i] = 6;
               } else if(aenergy[i] == 0) {
                  astatus[i] = 7;
                  // level up check 
                  if(adeadClip != null) {
                     adeadClip.play();
                  }
                  acount++;               
                  // end of level up 
               }
               check = 1;
            }
         }
         vx.removeElementAt(ith);
         vy.removeElementAt(ith);
         vz.removeElementAt(ith);
         if( dirx > -10 && diry > -10 && dirz >= 0 && check == 0) {
            vx.insertElementAt(new Integer(dirx), ith);
            vy.insertElementAt(new Integer(diry), ith);
            vz.insertElementAt(new Integer(dirz), ith);
         }
      }  
   }

   public void atranject(int adirx, int adiry, int adirz, int aith) {
      int acheck = 0;

      if(ashootClip != null) {
         ashootClip.play();
      }
      for(int i = 0; i < MS; i++) {
         if(energy[i] != 0 && xpos[i]+15 < adirx &&
            xpos[i]+50 > adirx && ypos[i]+10 < adiry && ypos[i]+30 > adiry) {
            if(deadClip != null) {
               deadClip.loop();
            }
            if(status[i] != 3) {
               energy[i]--;
            }
            if(energy[i] > 0) {
               status[i] = 2;
            } else if(energy[i] == 0) {
               status[i] = 3;
               if(deadClip != null) {
                  deadClip.play();
               }
               count++;
               if(count >= 3) {
                  gameOver();
               }
            }  // end of else if
            acheck = 1;
         }  // end of if
      } // for
      avx.removeElementAt(aith);
      avy.removeElementAt(aith);
      avz.removeElementAt(aith);
      if(adirx <= 612 && adiry <= 339 && adirz >= 0 && acheck == 0) {
         avx.insertElementAt(new Integer(adirx), aith);
         avy.insertElementAt(new Integer(adiry), aith);
         avz.insertElementAt(new Integer(adirz), aith);
      }
   }

   public void comMove(int i) {
      if(comdir[i] == 0) {
         comdir[i] = 1+(int)(Math.random()*20);
      }
      if(axpos[i] > 0 && aypos[i] >0 && comdir[i] < 11) {
         axpos[i]--;
         aypos[i]--;
         comdir[i]--;
         astatus[i] = comdir[i]%2;
         if(comdir[i] == 0) {
            aicom[i] = 0;
         }
      } else if(axpos[i] < 250 && aypos[i] < 250 && comdir[i] >= 11) {
         axpos[i]++;
         aypos[i]++;
         comdir[i]--;
         astatus[i] = comdir[i]%2;
         if(comdir[i] == 10) {
            comdir[i] = 0;
            aicom[i] = 0;
         }
      } else {
         comdir[i] = 0;
      }
      comdir2[i] = 1+(int)(Math.random()*20);

      if(axpos[i] > 0 && aypos[i] >0 && comdir[i] < 11) {
         axpos[i]--;
         aypos[i]++;

         astatus[i] = comdir2[i]%2;
         if(comdir2[i] == 0) {
            aicom[i] = 0;
         }
      } else if(axpos[i] < 592 && axpos[i] < 322 && comdir[i] >= 11) {
         axpos[i]++;
         aypos[i]--;
         astatus[i] = comdir2[i]%2;
         if(comdir2[i] == 10) {
            comdir2[i] = 0;
            aicom[i] = 0;
         }
      } else {
         comdir2[i] = 0;
      }
      // end of comdir2
   }

   public void comThrow(int i) {
      if(astatus[i] < 2) {
         astatus[i] = 2;
      }
      if(astatus[i] == 5) {
         astatus[i] = 0;
         aicom[i] = 0;
         avx.addElement(new Integer(axpos[i]+10));
         avy.addElement(new Integer(aypos[i]+10));
         avz.addElement(new Integer(5+(int)(Math.random()*25)));
      } else if(astatus[i] < 5) {
         astatus[i]++;
      }
   }

   public void computerAction() {
      for(int i=0;i<AMS;i++) {
         if(astatus[i] != 6 && astatus[i] != 7) {
            if(aicom[i] == 0) {
               aicom[i] =(int)(Math.random()*5);
            }
            switch(aicom[i]) {
               case 0 : break;
               case 1 : comMove(i); break;
               case 2 : comThrow(i); break;
               case 3 : comMove(i); break;
               case 4 : comThrow(i); break;             
            }
         } else if(astatus[i] == 6) {
            if(agetUp[i]++ == 10) {
               agetUp[i] = 0;
               astatus[i] = 0;
            }
         }
      }
   }

   public void showAll(Graphics g) {
      bufferGraphics.drawImage(bg, 0, 0, this);
      for(int j=0;j<MS;j++) {
         if(j != who) {
            bufferGraphics.drawImage(images1[status[j]], xpos[j], ypos[j], this);
         }
         tempx[j]=xpos[j]; tempy[j]=ypos[j];
      }

      bufferGraphics.drawImage(images1[status[who]], xpos[who], ypos[who], this);
      if(status[who] == 1) {
         bufferGraphics.drawImage(bg, tx, ty1, tx+5, ty2, tx, ty1, tx+5, ty2, this);
         for(int k=0; k < power; k++) {
            bufferGraphics.setColor(Color.blue);
            bufferGraphics.fillRect(tx=xpos[who]+65, ty1=ypos[who]+40-(k/5)*5, 5, 5);
         }
         ty2=ypos[who]+45;
      }
      for(int l=0;l<AMS;l++) {
         bufferGraphics.drawImage(images2[astatus[l]], axpos[l], aypos[l], this);
      }

      for(int i=0;i<vx.size();i++) {
         Integer xx =(Integer)vx.elementAt(i);
         Integer yy =(Integer)vy.elementAt(i);
         Integer zz =(Integer)vz.elementAt(i);
         if(zz.intValue()-1 >= 15) {
            bufferGraphics.drawImage(shadow, xx.intValue()-BSD, yy.intValue()-BSD, this);
            bufferGraphics.drawImage(ball, xx.intValue()-BSD, yy.intValue()-BSD-20, this);
         } else if(zz.intValue()-1 < 15 && zz.intValue()-1 > 1) {
            bufferGraphics.drawImage(shadow, xx.intValue()-BSD, yy.intValue()-BSD, this);
            bufferGraphics.drawImage(ball, xx.intValue()-BSD, yy.intValue()-BSD-20+(15-zz.intValue()-1), this);
         } else if(zz.intValue()-1 == 1) {
            bufferGraphics.drawImage(burst, xx.intValue()-BSD, yy.intValue()-BSD-20+(15-zz.intValue()-1), this);
            if(dropClip != null) {
               dropClip.play();
            }
         }
      }

      for(int ai=0;ai<avx.size();ai++) {
         Integer axx =(Integer)avx.elementAt(ai);
         Integer ayy =(Integer)avy.elementAt(ai);
         Integer azz =(Integer)avz.elementAt(ai);

         if(azz.intValue()-1 >= 15) {
            bufferGraphics.drawImage(shadow, axx.intValue()+BSD, ayy.intValue()+BSD, this);
            bufferGraphics.drawImage(ball, axx.intValue()+BSD, ayy.intValue()+BSD-20, this);
         } else if(azz.intValue()-1 < 15 && azz.intValue()-1 > 1) {
            bufferGraphics.drawImage(shadow, axx.intValue()+BSD, ayy.intValue()+BSD, this);
            bufferGraphics.drawImage(ball, axx.intValue()+BSD, ayy.intValue()+BSD-20+(15-azz.intValue()-1), this);
         } else if(azz.intValue()-1 == 1) {
            bufferGraphics.drawImage(burst, axx.intValue()+BSD, ayy.intValue()+BSD-20+(15-azz.intValue()-1), this);

            if(dropClip != null) {
               dropClip.play();
            }
         }
      }
   }

   public void ballXYZ() {
      for(int i=0;i<vx.size();i++) {
         Integer xx = (Integer)vx.elementAt(i);
         Integer yy = (Integer)vy.elementAt(i);
         Integer zz = (Integer)vz.elementAt(i);

         tranject(xx.intValue()-BSD, yy.intValue()-BSD, zz.intValue()-1, i);
      }
      for(int ai=0;ai<avx.size();ai++) {
         Integer axx = (Integer)avx.elementAt(ai);
         Integer ayy = (Integer)avy.elementAt(ai);
         Integer azz = (Integer)avz.elementAt(ai);

         atranject(axx.intValue()+BSD, ayy.intValue()+BSD, azz.intValue()-1, ai);
      }
      levelUpCkeck();
   }

   public void initGame(Graphics g) {
      int i, cx=400, cy=30;

      bufferGraphics.drawImage(bg, 0, 0, this);
      first = false;
      for(int j=0;j<MS;j++) {
         xpos[j] = 300+(int)(Math.random()*230);
         ypos[j] = 160+(int)(Math.random()*110);

         bufferGraphics.drawImage(images1[status[j]], xpos[j], ypos[j], this);
      }
      try {
         Thread.sleep(1000);
      } catch(InterruptedException e) {
         showStatus(e.toString());
      };

      for(i=0;i<30;i++) {
         bufferGraphics.setColor(new Color(100+i*5,100+i*5,100+i*5));
         Font font= new Font("Times New Roman", Font.BOLD+Font.ITALIC, 15);
         bufferGraphics.setFont(font);
         bufferGraphics.drawString("<< SNOWCRAFT GAME >>", cx-30, cy);
         bufferGraphics.drawString("Ʈ ǹ 48 1 ", cx-30, cy+20);

         if(level==1) {
            bufferGraphics.drawString("LEVEL 1", 250, 200);   
         } else if(level==2) {
            bufferGraphics.drawString("LEVEL 2", 250, 200);   
         } else if(level==3) {
            bufferGraphics.drawString("LEVEL 3", 250, 200);   
         }   		 		

         for(int k=0;k<AMS;k++) {
            bufferGraphics.drawImage(bg, axpos[k]+i-1, aypos[k]+i-1, axpos[k]+i-1+55, aypos[k]+i-1+36, axpos[k]+i-1, aypos[k]+i-1, axpos[k]+i-1+55, aypos[k]+i-1+36, this);
            bufferGraphics.drawImage(images2[i%2], axpos[k]+i, aypos[k]+i, this);
         }
         try {
            Thread.sleep(100);
         } catch(InterruptedException e) {
            showStatus(e.toString());
         };
         g.drawImage(bufferImage, 0, 0, this);
      }
      for(int l=0;l<AMS;l++) {
         axpos[l] += i;
         aypos[l] += i;
      }
      for(int j=0;j<MS;j++) {
         bufferGraphics.drawImage(bg, xpos[j], ypos[j], xpos[j]+63, ypos[j]+52, xpos[j], ypos[j], xpos[j]+63, ypos[j]+52, this);
      } 
   }

   public void gameOver() {
      //gameOver text print
      Font font= new Font("Times New Roman", Font.BOLD+Font.ITALIC, 30);
      bufferGraphics.setFont(font);
      bufferGraphics.setColor(Color.red);
      bufferGraphics.drawString("GAME OVER", 200, 150);

      if(endClip != null) {
         endClip.play();
      }
      stop();     //Ʊ Ǹ game over 
   }

   public void levelUp()   {
      // level up audio clip 
      if(levelClip != null) levelClip.play(); 
      for(int i=0;i<MS;i++) {
         status[i] = 0;
         energy[i] = 2;
      }
      for(int i = 0; i < AMS; i++) {
         astatus[i] = 0;
         aenergy[i] = 3;
         aicom[i] = 0;
         agetUp[i] = 0;
      }
      axpos[0] =  75; aypos[0] = 150;
      axpos[1] = 225; aypos[1] =  50;
      axpos[2] = 150; aypos[2] = 100;
      axpos[3] =  10; aypos[3] = 150;
      axpos[4] = 230; aypos[4] =  10;
      axpos[5] =  50; aypos[5] =  75;
      axpos[6] = 125; aypos[6] =  25;

      first = true;
      start();
      acount = 0; 
      count=0;
   }             
   //end of level up 

   public void levelUpCkeck() {     
      //level up check 
      if(acount >= 1 && acount <= 7) {
         if((level==1) && (acount ==3)) {               	
            level = 2;
            AMS = 5;
            speed = (long)1.0;

            levelUp();
         } else if((level==2) && (acount == 5) ) {
            level = 3;
            AMS = 7;
            speed = (long)0.5;

            levelUp();
         } else if ((level==3) &&(acount == 7)) {
            // text print ̱̽ϴ!
            Font font= new Font("Times New Roman", Font.BOLD+Font.ITALIC, 50);
            bufferGraphics.setFont(font);
            bufferGraphics.setColor(Color.blue);
            bufferGraphics.drawString("YOU WIN !!", 200, 150);

            // added end audio clip
            if(endClip != null) endClip.play();

            stop();
            // int point = 0;
            // scoreBoard(point);
         }
      }
   }  // end of levelUpCkeck()

   public void scoreBoard(int score) {
      AppletContext appletContext = getAppletContext();
      String queryString = getCodeBase()+"ScoreBoard/ScoreBoard.asp?score="+score;
      try {
         appletContext.showDocument(new URL(queryString), "_self");
      } catch(MalformedURLException ee) {
         appletContext.showStatus("URL Exception: " + ee);
      }
   }

   public void update(Graphics g) {
      paint(g);
   }

   public void paint(Graphics g) {
      if(first == true) {
         initGame(g);
      }
      showAll(g);
      ballXYZ();

      g.drawImage(bufferImage, 0, 0, this);
   }
}
