/*
 * Copyright (c) 2000 Yongwoo's Park. All Rights Reserved.
 */

package rndclub.game.godori;
import java.io.*;
import java.net.*;
import java.util.*;

/*
 * Ŭ̾Ʈ 1:1 Ʈŷ ϱ    ش.
 * ߳, κ , Ǵ   Ŭ̾Ʈ ޽ ų,
 * Ǵ ޾Ƶ̱  GServerPlayer ü ̿Ѵ.
 * Ŭ̾Ʈ ó 4001 Ʈ   ϸ,
 * PpiKki  ü ش ŬƮ Ʈŷ 
 *   GServerPlayer ü Ѵ.
 * GServerPlayer ü , κ ,      ִ.
 */
class GServerPlayer {
   // Ŭ̾Ʈ   ͸ ְ ޱ ,
   public Socket socket=null;       // Ʈŷ    ü
   //   Ŭ̾Ʈκ ͸ о̱  Է Ʈ
   public BufferedReader is=null;
   //   ͸ Ŭ̾Ʈ   Ʈ
   public PrintWriter os=null;

   //  ÷̾(Ŭ̾Ʈ)  κ()  
   Lobby lobby=null;
   //  ÷̾(Ŭ̾Ʈ)  (ӷ Ǵ ӹ)  
   GRoom room=null;

   // ÷̾  
   int point=0;         // Ŭ̾Ʈ  
   String id="noname";  //   Ǵ 
   String sex=null, age=null, win=null, lose=null, total=null, position=null;

   //  ϴ μ, ū ǹ̴ 
   int    intId=0;
   static int instanceCount=0;

   // GServerPlayer ü PpiKki  ü run() ޼ҵ忡 Ѵ.
   // ü ڷμ, (socket), κ (lobby),  (room)   ʿ
   // GServerPlayer ü      null̴.
   GServerPlayer(Socket socket, Lobby lobby, GRoom room) throws IOException {
      // ÷̾ ̵ 
      //  ϴ ͷμ ǹ̰ 
      intId = instanceCount++;

      // Ŭ̾Ʈ  Ʈũ κ 
      // ͸ а    Ʈ ü Ѵ.
      is = new BufferedReader(new InputStreamReader(socket.getInputStream()));
      os = new PrintWriter(socket.getOutputStream(), true);

      // ó
      if(is == null) {
         throw new IOException();
      }
      if(os == null) {
         throw new IOException();
      }

      // , κ ,     
      this.socket = socket;
      this.lobby = lobby;
      this.room = room;
   }

   // Ŭ̾Ʈ ó ϸ,
   // Ŭ̾Ʈ Ʈũ  Ŭ̾Ʈ ׽Ʈ ϱ 
   // ó  ̸ Ȯϱ  ޽ .
   public void validation() {
      if(is != null) {
         try {
            sendMessage("Username"); //  ̵ Ŭ̾Ʈ û
            id = receiveMessage();   // Ŭ̾Ʈκ  ̵ о
         } catch(SocketException e) {
            clear();    // SocketException ܰ ߻ϸ ߸  
         } catch(IOException e) {
            clear();    // IOException ܰ ߻ϸ ߸  
         }
      }
   }

   //  ü Ǿ ִ Ŭ̾Ʈ ־ ͸ Ѵ.
   public void sendMessage(String message) {
      if(message != null) {
         os.println(message); // Ʈũ  Ʈ ͸ 
         os.flush();          // ݵ flush   ־ ϴ.
         if(os.checkError()) {
            // ½ÿ ܰ ߻ߴٸ,
            // Ŭ̾Ʈ Ʈũ   ̴.
            // , ش Ŭ̾Ʈ κ/뿡 ν,
            // Ŭ̾Ʈ   ó ־ Ѵ.
            lobby.removePlayer(this);
         }
      }
   }

   //  ü Ǿ ִ Ŭ̾Ʈκ  ͸ оδ.
   public String receiveMessage() throws SocketException, IOException {
      String message=null;
      try {
         message = is.readLine();   // Ŭ̾Ʈκ   ͸ о
         if(message == null) {
            // о Ͱ null  , IOException ܸ ߻Ų.
            throw(new IOException("Null pointer received...."));
         }
      } catch(SocketException e) {
         // SocketException ܰ ߻ϸ ״ ȣ  .
         // ַ ȣ  κ   Ǵ   ̴.
         // SocketException ܰ ߻ߴٴ  Ŭ̾Ʈ Ʈũ
         // ٴ  ǹϹǷ ̿  ó  ־ Ѵ.
         throw(e);
      } catch(InterruptedIOException e) {
         // ũ ߿  ܷμ,
         // Ŭ̾Ʈ Ʈŷ ϴ  ū  .
         message = "";
      } catch(IOException e) {
         // IOException ܰ ߻ϸ ״ ȣ  .
         // ַ ȣ  κ   Ǵ   ̴.
         // IOException ܰ ߻ߴٴ  Ŭ̾Ʈ Ʈũ
         // ٴ  ǹϹǷ ̿  ó  ־ Ѵ.
         throw(e);
      } catch(Exception e) {
         // ũ ߿  ܷμ,
         // Ŭ̾Ʈ Ʈŷ ϴ  ū  .
         message = "";
      }
      return(message);
   }

   // Ŭ̾Ʈ Ǿ ִ  Ʈ ݰ,
   // Ʈũ  Ѵ.
   protected void clear() {
      try {
         if(is != null) {
            is.close();          // Ͽ  Է Ʈ ݴ´.
            is = null;
         }
      } catch(Exception e) {
         System.out.println(e);
         e.printStackTrace();
      }

      try {
         if(os != null) {
            os.close();          // Ͽ   Ʈ ݴ´.
            os = null;
         }
      } catch(Exception e) {
         System.out.println(e);
      }

      try {
         if (socket != null) {
            socket.close();      //  ݴ´.
            socket = null;
         }
      } catch (Exception e) {
         System.out.println(e);
         e.printStackTrace();
      }
   }

   // ϰ ִ ÷̾  Ͽ شϴ ڿ  ش.
   String getProfileMessage() {
      String profileMessage=null;

      profileMessage = point+",";
      profileMessage += sex+",";
      profileMessage += age+",";
      profileMessage += win+",";
      profileMessage += lose+",";
      profileMessage += total+",";
      profileMessage += position;

      return(profileMessage);
   }

   //  ÷̾  (, ,  ) ڿ  ش.
   String getPlayerInfoMessage() {
      String playerInfoMessage="null,null";

      if(room == null) {
         playerInfoMessage = ",";
      } else {
         if(room.inSession(this)) {
            playerInfoMessage = room.roomId+",";
         } else {
            playerInfoMessage = room.roomId+",";
         }
      }
      return(playerInfoMessage);
   }

   // Object Ŭ ϰ ִ toString() ޼ҵ带 Ͽ
   // ÷̾ ü   ϴ ڿ  ش.
   public String toString() {
      return("Player["+id+","+point+"]: Socket["+socket+"], Lobby["+lobby+"], Room["+room+"]");
  }
}
