<%@ page contentType="text/html; charset=euc-kr" %>
<%@ page errorPage="/member/ErrorPage.jsp" %>

<%@ page import="java.util.*" %>
<%@ page import="org.rndclub.member.*" %>

<jsp:useBean id="memberContext" class="org.rndclub.member.MemberContextBean" scope="session" />
<%
   if(!memberContext.isAdmin()) {
      request.setAttribute("forwardUrl", "/rndclub/member/MemberLoginForm.jsp");
      throw new Exception("  Դϴ. ڷ α Ͻʽÿ.");
   }
%>

<jsp:useBean id="memberProcess" class="org.rndclub.member.MemberProcessBean" scope="page" />

<%
   int pageNum=1;

   try {
      pageNum = Integer.parseInt(request.getParameter("pageNum"));
   } catch(NumberFormatException e) {
      pageNum = 1;
   }
   if(!memberProcess.availablePage(pageNum)) {
      pageNum = 1;
   }

   ArrayList list = new ArrayList();

   memberProcess.setRowPerPage(10);
   list = memberProcess.selectPage(pageNum);
%>

<html>
<head>
<title>Member List</title>
<style type=text/css>
   <!--
   A:link{font:10pt ,Arial;COLOR:#0000A0;text-decoration:none
   A:active{font:10pt ,Arial;COLOR:#0000A0;text-decoration:none
   A:visited{font:10pt ,Arial;COLOR:#0000A0;text-decoration:none
   td{font:10pt ,Arial;COLOR:#000000;text-decoration:none
   -->
</style>
</head>

<body bgcolor=#F5EDE8 text=black link=blue vlink=purple alink=red
      topmargin=0 leftmargin=0 marginwidth=0 marginheight=0>

<!-- Header -->

<%@ include file="/member/HeaderPage.jsp" %>

<!-- Body -->

<center>
<table border=0 cellpadding=4 cellspacing=1 width=96%>
   <tr>
      <td align=left valign=bottom><font size=2 color=brown>
      Item: <%= (pageNum-1)*memberProcess.getRowPerPage() %>/
            <%= memberProcess.getNumberOfRow() %>,&nbsp;&nbsp; 
      Page: <%= pageNum %>/<%= memberProcess.getNumberOfPage() %></td>
      <td align=right>
         <a href=/rndclub/member/MemberRegisterForm.jsp>
            <img src=/rndclub/member/images/write.gif border=0></a></td>
   </tr>
</table>

<table border=0 cellpadding=0 cellspacing=1 width=96%>
   <tr><p><font size=2 color=white>
      <th align=center bgcolor=#9FAF9F>SeqNum</th>
      <th align=center bgcolor=#9FAF9F>ID</th>
      <th align=center bgcolor=#9FAF9F≯</th> 
      <th align=center bgcolor=#9FAF9F>ֹεϹȣ</th>       
      <th align=center bgcolor=#9FAF9F>ó</th>
      <th align=center bgcolor=#9FAF9F></th>
      <th align=center bgcolor=#9FAF9F></th>
   </font></p></tr>

<%
   for(int i=0 ; i<list.size() ; i++) {
      MemberBean member = (MemberBean)list.get(i);
%>
      <tr>
         <td align=center>
            <%= member.getSeqNum() %></td>
         <td align=center>
            <a href="/rndclub/member/MemberInformation.jsp?seqNum=<%= member.getSeqNum() %>&pageNum=<%= pageNum %>">
            <%= member.getId() %></a></td>
         <td align=center>
            <a href="mailto:<%= member.getEmail() %>">
               <%= member.getName() %></a></td>
         <td align=center>
            <%= member.getResidentNum1() %>-
            <%= member.getResidentNum2() %></td>       
         <td align=center>
            <%= member.getPhoneNum1() %>-
            <%= member.getPhoneNum2() %>-
            <%= member.getPhoneNum3() %></td>
         <td align=center>
            <%= member.getJob() %></td>
         <td align=center>
            <%= member.getWriteDate() %></td>
      </tr>
<%
   }
%>
</table>

<table border=0 width=96%>
   <tr align=center>
      <td bgcolor=#cccccc>
<%
   if(memberProcess.availablePrevPage(pageNum)) {
%>
      <a href="/rndclub/member/MemberList.jsp?pageNum=<%= (pageNum-1) %>">
         <img src=/rndclub/member/images/back.gif border=0 alt= align=absmiddle></a>
<%
   } else {
%>
      <img src=/rndclub/member/images/back.gif border=0 alt= align=absmiddle>
<%
   }

   if(memberProcess.availableNextPage(pageNum)) {
%>
      <a href=/member/MemberList.jsp?pageNum=<%= (pageNum+1) %>">
      <img src=/rndclub/member/images/next.gif border=0 alt= align=absmiddle></a>
<%
   } else {
%>
      <img src=/rndclub/member/images/next.gif border=0 alt= align=absmiddle>
<%
   }
%>
      </td>
   </tr>
   <tr>
      <td bgcolor=#efefdf>&nbsp;</td>
   </tr>
</table>
</center>

<!-- Footer -->

<%@ include file="/member/FooterPage.jsp" %>

</body>
</html>
