<%@ page contentType="text/html; charset=euc-kr" %>
<%@ page errorPage="/member/ErrorPage.jsp" %>

<%@ page import="org.rndclub.member.*" %>

<jsp:useBean id="member" class="org.rndclub.member.MemberBean" scope="page" />
<jsp:useBean id="memberProcess" class="org.rndclub.member.MemberProcessBean" scope="page" />
<jsp:useBean id="memberContext" class="org.rndclub.member.MemberContextBean" scope="session" />
<%
   String uploadPath = getServletContext().getRealPath("/member/upload");

   MultipartRequest multi = new MultipartRequest(request,
                                                 uploadPath,
                                                 5*1024*1024);

//   member.setSeqNum(seqNum);
   member.setId(multi.getParameter("id"));
   member.setPassword(multi.getParameter("password"));
   member.setHintQ(multi.getParameter("hintQ"));
   member.setHintA(multi.getParameter("hintA"));
   member.setEmail(multi.getParameter("email"));
   member.setName(multi.getParameter("name"));
   member.setResidentNum1(multi.getParameter("residentNum1"));
   member.setResidentNum2(multi.getParameter("residentNum2"));
   member.setZipNum1(multi.getParameter("zipNum1"));
   member.setZipNum2(multi.getParameter("zipNum2"));
   member.setAddress(multi.getParameter("address"));
   member.setPhoneNum1(multi.getParameter("phoneNum1"));
   member.setPhoneNum2(multi.getParameter("phoneNum2"));
   member.setPhoneNum3(multi.getParameter("phoneNum3"));
   member.setJob(multi.getParameter("job"));

   File imageFile = multi.getFile("image");
   if(imageFile != null) {
      member.setImageType(multi.getContentType("image"));
      member.setImage(new BufferedInputStream(new FileInputStream(imageFile)));
   }

   memberProcess.register(member);

   if(memberContext.isAdmin()) {
      response.sendRedirect("/rndclub/member/MemberList.jsp?pageNum=1");
   } else {
      response.sendRedirect("/rndclub/member/MemberLoginForm.jsp");
   }
%>
